Subject: Re: linux-next: add utrace tree

From: Ananth N Mavinakayanahalli <[email-masked]>
Date: Fri, 29 Jan 2010 15:01:36 +0530

On Fri, Jan 29, 2010 at 10:11:16AM +0100, Ingo Molnar wrote:
> 
> * Ananth N Mavinakayanahalli <[email-masked]> wrote:
> 
> > On Fri, Jan 29, 2010 at 08:39:07AM +0100, Ingo Molnar wrote:
> > 
> > ...
> > 
> > > When we merged kprobes ~10 years ago we made the (rather bad) mistake of 
> > > merging a raw, opaque facility and leaving 'the rest' up to some other entity. 
> > > IBM kprobes hackers vanished the day the original kprobes code went upstream 
> > > and the high level entity never truly materialized in-kernel, for nearly a 
> > > decade!
> > 
> > I don't know what you are referring to here... Kprobes was merged in 2.6.9 
> > (~August 2004 -- less than 6 years ago). [...]
> 
> Ok, 6 years then :-)
>
> > [...] Since then, we did work on ports to powerpc and s390. We implemented 
> > kretprobes. We made it much scalable using RCU; we did the powerpc booster 
> > to skip single-step when possible, not to mention various bug fixes over the 
> > years.
> 
> Except it had no real in-kernel user.

Not that I want to rebut you Ingo, but there were in-kernel users since 2006
(net/ipv4/tcp_probe.c) :-)

Aside, I am also glad that we have more flexibility with the perf
integration.

Ananth